<?php

    class ListenOrders {

        public function __construct () {

            $nc_core = nc_Core::get_object();
		    $nc_core->event->bind($this, array('addMessage' => 'new_order') ); //новый заказ
		    $nc_core->event->bind($this, array('updateMessage' => 'update_order') ); //изменение объекта заказа (тут триггерится все, т.к. меняется статус: оплата, отмена заказа, простое изменение статуса)

        }

	    public function update_order ($site_id, $subdivision_id, $infoblock_id, $component_id, $object_id) {

            global $db;

		    $nc_core = nc_Core::get_object();
		    $system_env = $nc_core->get_settings();
		    $MODULE_VARS = $nc_core->modules->get_module_vars();

		    if ( ($MODULE_VARS["smsgate"]["SMSGATE_CATALOGUE_ID"] == $site_id) && ($MODULE_VARS["smsgate"]["SMSGATE_ORDER_SUB_ID"] == $subdivision_id) && ($MODULE_VARS["smsgate"]["SMSGATE_ORDER_COMPONENT_ID"] == $component_id) ) {

			    //Определяем, какой ивент задействовать, извлекая сохраненный клон заказа и сравнивая, что произошло со статусами
			    $cloned_status = $db->get_var("SELECT status FROM smsgate_cloned_orders WHERE order_id=$object_id");
			    $current_status = $db->get_var("SELECT `".$MODULE_VARS["smsgate"]['SMSGATE_ORDER_STATUS_FIELD_NAME']."` FROM Message".$MODULE_VARS["smsgate"]['SMSGATE_ORDER_COMPONENT_ID']." WHERE Subdivision_ID=".$MODULE_VARS["smsgate"]['SMSGATE_ORDER_SUB_ID']." AND Message_ID=$object_id");

			    if ($cloned_status != $current_status) { //значит поменялся статус, а другие изменения с заказом модулю не интересны

			        if ($current_status == $MODULE_VARS["smsgate"]["SMSGATE_ORDER_PAYED_STATUS_NAME"]) { //оплачен заказ

			            $event_info = $db->get_results("SELECT * FROM smsgate_templates WHERE event='pay'", "ARRAY_A");
					    $this->send_sms($MODULE_VARS["smsgate"], $event_info, $object_id);

				    }
			        elseif ($current_status == $MODULE_VARS["smsgate"]["SMSGATE_ORDER_CANCELED_STATUS_NAME"]) { //отменен заказ

			            $event_info = $db->get_results("SELECT * FROM smsgate_templates WHERE event='cancel'", "ARRAY_A");
					    $this->send_sms($MODULE_VARS["smsgate"], $event_info, $object_id);

				    }
			        else {

			            $event_info = $db->get_results("SELECT * FROM smsgate_templates WHERE event='change'", "ARRAY_A");
					    $this->send_sms($MODULE_VARS["smsgate"], $event_info, $object_id);

			        }

				    $this->updateOrder($MODULE_VARS["smsgate"], $object_id);
			    }
		    }
	    }

	    public function new_order ($site_id, $subdivision_id, $infoblock_id, $component_id, $object_id) {

            global $db;
		    $nc_core = nc_Core::get_object();
		    $system_env = $nc_core->get_settings();
		    $MODULE_VARS = $nc_core->modules->get_module_vars();

		    if ( ($MODULE_VARS["smsgate"]["SMSGATE_CATALOGUE_ID"] == $site_id) && ($MODULE_VARS["smsgate"]["SMSGATE_ORDER_SUB_ID"] == $subdivision_id) && ($MODULE_VARS["smsgate"]["SMSGATE_ORDER_COMPONENT_ID"] == $component_id) ) {

			    $this->storeOrder($MODULE_VARS["smsgate"], $object_id);

			    $event_info = $db->get_results("SELECT * FROM smsgate_templates WHERE event='new'", "ARRAY_A");
			    $this->send_sms($MODULE_VARS["smsgate"], $event_info, $object_id);

		    }

        }

	    public function send_sms($mvars, $info, $msg_id) {

            global $db;

		    $sql = "SELECT * FROM Catalogue WHERE Catalogue_ID=".$mvars["SMSGATE_CATALOGUE_ID"];
		    $site_info = $db->get_row($sql, "ARRAY_A");

		    $project_name = $db->get_var("SELECT Value FROM Settings WHERE `Key`='ProjectName'");

		    $sql = "SELECT * FROM Message".$mvars['SMSGATE_ORDER_COMPONENT_ID']." WHERE Subdivision_ID=".$mvars['SMSGATE_ORDER_SUB_ID']." AND Message_ID=$msg_id";
		    $order_info = $db->get_row($sql, "ARRAY_A");

		    $current_status = $order_info[$mvars['SMSGATE_ORDER_STATUS_FIELD_NAME']];
		    $status_field_info = $db->get_row("SELECT * FROM Field WHERE Class_ID=".$mvars['SMSGATE_ORDER_COMPONENT_ID']." AND Field_Name='".$mvars['SMSGATE_ORDER_STATUS_FIELD_NAME']."'", "ARRAY_A");

		    if ($status_field_info['TypeOfData_ID'] == 4 && $status_field_info['Format']) { //значит поле статус имеет формат типа список, надо получить значения списка

		        $order_list_name = $status_field_info['Format'];
			    $statuses = $db->get_results("SELECT * FROM Classificator_".$order_list_name." WHERE Checked=1", "ARRAY_A");

			    foreach ($statuses as $db_status) {

			        if ($current_status == $db_status[$mvars['SMSGATE_ORDER_STATUS_FIELD_NAME'].'_ID']) {

			            $current_status = $db_status[$mvars['SMSGATE_ORDER_STATUS_FIELD_NAME'].'_Name'];
					    break;

			        }

			    }

		    }

		    $incore_ordered_products = "";
		    $sql = "SHOW TABLES LIKE 'Netshop_OrderGoods'";
		    $prod_order_exist = $db->get_row($sql, "ARRAY_A");

		    if ($prod_order_exist) { //Значит редакция Business+ и таблица стандартная со списком продуктов существует

		        $sql = "SELECT * FROM Netshop_OrderGoods WHERE Order_ID=$msg_id";
			    $ordered_products = $db->get_results($sql, "ARRAY_A");
			    $oprod = array();
			    $total = 0;

			    if ($ordered_products) {

			        foreach ($ordered_products as $opr) {

			            $cc_id = $opr['Item_Type'];
					    $prod_id = $opr['Item_ID'];
					    $qty = $opr['Qty'];
					    $price = $opr['ItemPrice'];
					    $cur_total = $qty * $price;
					    $total += $cur_total;
					    $prod_name = $db->get_var("SELECT `".$mvars['SMSGATE_PRODUCT_NAME_FIELD_NAME']."` FROM Message".$cc_id." WHERE Message_ID=".$prod_id);
					    $oprod[] = $prod_name."; ".$qty." шт.; стоимость: ".$cur_total." руб.";

			        }

				    $incore_ordered_products = implode("\n", $oprod)."\nИтого: ".$total." руб.";

			    }

		    }

		    $address_fields = explode(";", $mvars['SMSGATE_CLIENT_ADDRESS_FIELD_NAME']);
		    $full_client_address = "";

		    if ($address_fields) {

		        $tmpAddr = array();

		        foreach ($address_fields as $addr_fld_name) {

		            if ($addr_fld_name) {
					    $tmpAddr[] = $order_info[trim($addr_fld_name)];
				    }

		        }

		        $full_client_address = implode("; ", $tmpAddr);

		    }
		    else {
			    $full_client_address = $order_info[$mvars['SMSGATE_CLIENT_ADDRESS_FIELD_NAME']];
		    }

		    $tpl_vars = array(
			    "%PIR_SHOP_NAME%" => "\"".$project_name."\"",
			    "%PIR_ORDER_ID%" => $msg_id,
			    "%PIR_STATUS%" => $current_status,
			    "%PIR_CLIENT_NAME%" => $order_info[$mvars['SMSGATE_CLIENT_FIO_FIELD_NAME']],
			    "%PIR_CLIENT_PHONE%" => $order_info[$mvars['SMSGATE_CLIENT_PHONE_FIELD_NAME']],
			    "%PIR_CLIENT_EMAIL%" => $order_info[$mvars['SMSGATE_CLIENT_EMAIL_FIELD_NAME']],
			    "%PIR_CLIENT_ADDRESS%" => $full_client_address,
			    "%PIR_ORDERED_PRODUCTS%" => $incore_ordered_products,
		    );

		    foreach ($info as $event) {

		        if ($event["is_active"]) { //если администратор установил галочку на отсылку смс по этому событию

				    $tpl = $event["template"];
				    $tpl = $this->updateConstants($tpl_vars, $tpl);

				    $customer_phone = $order_info[$mvars['SMSGATE_CLIENT_PHONE_FIELD_NAME']];
				    $customer_phone = str_replace("-", "", $customer_phone);
				    $customer_phone = str_replace("+", "", $customer_phone);
				    $customer_phone = str_replace("(", "", $customer_phone);
				    $customer_phone = str_replace(")", "", $customer_phone);

				    $phone = ($event["user_type"] == "admin" ? $mvars["SMSGATE_ADMIN_PHONE"] : $customer_phone);

				    $sms_xml = '
					<?xml version="1.0" encoding="utf-8" ?>
					<request>
					<message type="sms">
					    <sender>'.$mvars['SMSGATE_PIR_SENDER_NAME'].'</sender>
					    <text>'.$tpl.'</text>
					    <abonent phone="'.$phone.'" number_sms="1" />
					</message>

					<security>
					    <login value="'.$mvars['SMSGATE_PIR_USERNAME'].'" />
					    <password value="'.$mvars['SMSGATE_PIR_PASSWORD'].'" />
					</security>
					</request>
				    ';

				    $href = $mvars['SMSGATE_PIR_SERVER_NAME']; // адрес сервера
				    $ch = curl_init();
				    curl_setopt ($ch, CURLOPT_HTTPHEADER, array ('Content-type: text/xml','charset=utf-8','Expect:'));
				    curl_setopt ($ch, CURLOPT_RETURNTRANSFER, true);
				    curl_setopt ($ch, CURLOPT_SSL_VERIFYPEER, 0);
				    curl_setopt ($ch, CURLOPT_SSL_VERIFYHOST, 0);
				    curl_setopt ($ch, CURLOPT_POST, true);
				    curl_setopt ($ch, CURLOPT_POSTFIELDS, $sms_xml);
				    curl_setopt ($ch, CURLOPT_URL, $href);
				    $result = curl_exec($ch);
				    curl_close($ch);

				    $this->logEvent($event['event'], $event['user_type'], $sms_xml, $result);

			    }

		    }

        }

	    public function updateConstants($vars, $tpl) {

            foreach ($vars as $var_name => $var_val) {
			    $tpl = str_replace($var_name, $var_val, $tpl);
		    }

		    return $tpl;

        }

	    public function storeOrder($mvars, $msg_id) { //при новом заказе сохраняем в отдельную табличку айди заказа и его статус, чтобы при последующем изменении сравнивать статусы и понимать, что произошло с заказом - оплата, отмена или другая смена статуса

            global $db;

		    $sql = "SELECT * FROM Message".$mvars['SMSGATE_ORDER_COMPONENT_ID']." WHERE Subdivision_ID=".$mvars['SMSGATE_ORDER_SUB_ID']." AND Message_ID=$msg_id";
		    $order_info = $db->get_row($sql, "ARRAY_A");

		    $status = $order_info[$mvars['SMSGATE_ORDER_STATUS_FIELD_NAME']];

		    $db->query("INSERT INTO smsgate_cloned_orders (order_id, status) VALUES ($msg_id, '$status')");

        }

	    public function updateOrder($mvars, $msg_id) {

            global $db;

		    $sql = "SELECT * FROM Message".$mvars['SMSGATE_ORDER_COMPONENT_ID']." WHERE Subdivision_ID=".$mvars['SMSGATE_ORDER_SUB_ID']." AND Message_ID=$msg_id";
		    $order_info = $db->get_row($sql, "ARRAY_A");

		    $status = $order_info[$mvars['SMSGATE_ORDER_STATUS_FIELD_NAME']];

		    $sco_id = $db->get_var("SELECT id FROM smsgate_cloned_orders WHERE order_id=".$msg_id);

		    $db->query("UPDATE smsgate_cloned_orders SET status='$status' WHERE id=$sco_id");

        }

	    public function logEvent($event, $utype, $xml, $answer) {

            $handle = fopen($_SERVER['DOCUMENT_ROOT']."/netcat/modules/smsgate/smsgate_log.txt", "a");
		    fwrite($handle, "Time: ".date('d.m.Y H:i:s').". Event: $event. User type: $utype. XML DATA: \r\n $xml \r\n .ANSWER FROM SERVER: $answer \r\n\r\n");
		    fclose($handle);

        }

    }

    $listenObj = new  ListenOrders();

    function pir_send_sms($mobile, $text) {

	    $nc_core = nc_Core::get_object();
	    $MODULE_VARS = $nc_core->modules->get_module_vars();
	    $mvars = $MODULE_VARS['smsgate'];

	    $sms_xml = '
		<?xml version="1.0" encoding="utf-8" ?>
		<request>
		<message type="sms">
		    <sender>'.$mvars['SMSGATE_PIR_SENDER_NAME'].'</sender>
		    <text>'.$text.'</text>
		    <abonent phone="'.$mobile.'" number_sms="1" />
		</message>

		<security>
		    <login value="'.$mvars['SMSGATE_PIR_USERNAME'].'" />
		    <password value="'.$mvars['SMSGATE_PIR_PASSWORD'].'" />
		</security>
		</request>
	    ';

	    $href = $mvars['SMSGATE_PIR_SERVER_NAME']; // адрес сервера
	    $ch = curl_init();
	    curl_setopt ($ch, CURLOPT_HTTPHEADER, array ('Content-type: text/xml','charset=utf-8','Expect:'));
	    curl_setopt ($ch, CURLOPT_RETURNTRANSFER, true);
	    curl_setopt ($ch, CURLOPT_SSL_VERIFYPEER, 0);
	    curl_setopt ($ch, CURLOPT_SSL_VERIFYHOST, 0);
	    curl_setopt ($ch, CURLOPT_CRLF, true);
	    curl_setopt ($ch, CURLOPT_POST, true);
	    curl_setopt ($ch, CURLOPT_POSTFIELDS, $sms_xml);
	    curl_setopt ($ch, CURLOPT_URL, $href);
	    $result = curl_exec($ch);
	    curl_close($ch);

    }

?>